
#
# Example of using main in a Python program.
# 
# If run from the command line, code that is outside of __main__
# will run before or after __main__ dependent on where it is in 
# the file.
#
# Functions in this file can be invoked directly from other Python files
# but the code that is outside the functions will run every time.
#

print()
print('This code is at top of file')
print('It runs before __main__ when we execute')
print('this file or when we import this file.')


def foo():
    print()
    print('Welcome to the foo function.')
    print()
    

def main():
    print()
    print('This is the main function.')
    print('In Python, main() is not special.')
    print('This makes main() very sad.')
    
    foo()
    
    print('foo() has returned and we are back in main')
    print()

    
if __name__ == '__main__':
    print()
    print('This is __main__.')
    print('It is special in Python.')
    print('It is where execution begins.')
    
    main()

    print('main() has returned and we are back in __main__')
    print()
    
    
print()
print('This code is after __main__')
print('It runs after __main__ when we execute')
print('this file or when we import this file.')
